<?php
define( 'SAVEQUERIES', true);
require_once( 'wp-load.php' );
function my_scope() {
  global $wpdb;

  /*
  * カテゴリーとタグに同じターム名IRとスラッグirのタームタクソノミーを追加します。

  * wp_term_taxonomyには2レコード追加されます。

  * wp_termsには、WordPress 4.1 以降は2レコードが
  * WordPress 4.1 未満は1レコード追加されます。

  */
  $ret = wp_insert_term( 'IR',   'category', array( 'slug' => 'ir' ) );
  print_r( $ret );

  $ret = wp_insert_term( 'IR',   'post_tag', array( 'slug' => 'ir' ) );
  print_r( $ret );

  // タームタクソノミーの取得
  $ret = get_term_by( 'name', 'IR', 'post_tag' );
  print_r( $ret );

  // タームタクソノミーの更新
  $ret = wp_update_term( $ret->term_id, 'post_tag', array( 'slug' => 'ir_tag' ) );
  print_r( $ret );

  // タームタクソノミーを ID 1 の投稿に関連づける。既存の関連は削除する。
  $ret = wp_set_object_terms( 1, 'ir', 'category', false );

  // タームタクソノミーを ID 1 の投稿に追加で関連づける
  $ret = wp_set_object_terms( 1, 'ir_tag', 'post_tag', true );
  print_r( $ret );

  // ID 1 の投稿に関連づけられたタームタクソノミーを取得する
  $ret = wp_get_object_terms( 1, array( 'category', 'post_tag' ) );
  print_r($ret);

  // SQLでwp_term_relationsipsテーブルを確認する
  $ret = $wpdb->get_results( "SELECT * FROM $wpdb->term_relationships WHERE object_id = 1" );
  print_r( $ret );

  // SQLでwp_posts => wp_term_relationships => wp_term_taxonomy => wp_terms までの関連を確認する
  $sql = "
    SELECT
           a.ID,
           a.post_title,
           a.post_name,
           c.term_taxonomy_id,
           c.taxonomy,
           d.term_id,
           d.name,
           d.slug
    FROM   $wpdb->posts AS a
    INNER JOIN
           $wpdb->term_relationships AS b
    ON     a.ID = b.object_id
    INNER JOIN
           $wpdb->term_taxonomy AS c
    ON     b.term_taxonomy_id = c.term_taxonomy_id
    INNER JOIN
           $wpdb->terms as d
    ON     c.term_id = d.term_id
    WHERE  a.ID = 1
  ";
  $ret = $wpdb->get_results( $sql );
  print_r($ret);

  // 投稿 ID 1 とタグの関連づけを解除する
  $ret = wp_set_object_terms( 1, null, 'post_tag', false );

  // 投稿 ID 1 とカテゴリーの関連づけを term_id 1 の未分類に戻す
  $ret = wp_set_object_terms( 1, 1, 'category', false );

  // 追加したタームタクソノミーを削除して最初の状態に戻す
  $ret = get_term_by( 'name', 'IR', 'category' );
  wp_delete_term( $ret->term_id, 'category' );

  $ret = get_term_by( 'name', 'IR', 'post_tag' );
  wp_delete_term( $ret->term_id, 'post_tag' );

}
my_scope();

