<?php
require_once( 'wp-load.php' );
function my_scope() {
  // いずれもサイト名を取得して出力します。

  // 基本的に同じ出力になりますが、通過するフックが異なるためその影響を受ける可能性があります。

  // 1. $wpdbを使用
  global $wpdb;
  $table = esc_sql( $wpdb->options );
  $ret = $wpdb->get_var( "SELECT option_value FROM $table WHERE option_name = 'blogname'" );
  echo esc_html( $ret );

  // 2. get_option()を使用
  $ret = get_option( 'blogname' );
  echo esc_html( $ret );

  // 3. bloginfo()を使用
  bloginfo( 'name' );


  // 設定値の保存（ autoload = yes ）
  add_option( 'my-book-name', 'first book name', '', 'yes' );

  // autoloadのアップデート（ autoload = no ）
  $wpdb->query( "UPDATE $table SET autoload = 'no' WHERE option_name = 'my-book-name'" );

  // 設定値の更新
  update_option( 'my-book-name', 'Essential WordPress' );

  // 設定値の取得
  $ret = get_option( 'my-book-name' );

  // 設定値の削除
  delete_option( 'my-book-name' );
}
my_scope();

